program AlienRiver;
uses Crt;
const VRAM = $b800;
      GroundCol = Red;
      WallCol = LightGray;
      PlayerCol = Green;
      ShipCol = Magenta;
      MineCol = Black;
      AlienCol = Cyan;
      DeadCol = Brown;
      WaterCol = Blue;
      NumAli = 20;
      GameQuit: Boolean = False;
      Crate = 8;
type WaterType = (Avoid, Swim, Crawl);
     Alien = record
              x, y, Col, UnderCol: Byte;
              Water: WaterType
             end;
var PlaX, PlaY, i, j, BakCol, MineInv, Kills, CrateX, CrateY: Byte;
    LevelQuit, Moved, Action, CrateTaken: Boolean;
    k: Char;
    Aliens: array[1..NumAli] of Alien;

procedure DrawPx(x, y, Color: Byte);
var Offset: Word;
begin
 Offset:= 2*( x + 80*(y div 2) ) + 1;
 if Odd(y) then mem[VRAM:Offset]:= mem[VRAM:Offset] and $0f or 16*Color
           else mem[VRAM:Offset]:= mem[VRAM:Offset] and $f0 or Color
end;

function GetPx(x, y: Byte): Byte;
var Offset: Word;
begin
 Offset:= 2*( x + 80*(y div 2) ) + 1;
 if Odd(y) then GetPx:= mem[VRAM:Offset] div 16
           else GetPx:= mem[VRAM:Offset] and $0f
end;

procedure DrawBox(x, y, w, h, Color: Byte; ForceFrame: Boolean);
var i, j: Byte;
begin
 for j:=y to y+h-1 do
   for i:=x to x+w-1 do DrawPx(i, j, Color);
 for i:=x-1 to x+w do begin if (GetPx(i, y-1)=0) or ForceFrame then DrawPx(i, y-1, WallCol);
                            if (GetPx(i, y+h)=0) or ForceFrame then DrawPx(i, y+h, WallCol)
                      end;
 for i:=y to y+h-1 do begin if (GetPx(x-1, i)=0) or ForceFrame then DrawPx(x-1, i, WallCol);
                            if (GetPx(x+w, i)=0) or ForceFrame then DrawPx(x+w, i, WallCol)
                      end
end;

function Spc(Length: Byte; Ch: Char): string;
var i: Byte;
    s: string[140];
begin
 s:= '';
 for i:=1 to Length do s:= s + Ch;
 Spc:= s
end;

procedure SoundOK;
var i: Byte;
begin
 for i:=0 to 150 do begin
                     Sound(200+2*i);
                     Delay(1)
                    end;
 NoSound
end;

procedure SoundBoom;
var i: Byte;
begin
 for i:=200 downto 30 do begin
                          Sound(i);
                          Delay(1)
                         end;
 NoSound
end;

procedure SoundSqueek;
var i: Word;
begin
 for i:=2500 to 2700 do begin
                          Sound(i);
                          Delay(1)
                         end;
 NoSound
end;

procedure SoundTwo(first, second: Word);
begin
 Sound(first); Delay(40); NoSound;
 Delay(30);
 Sound(second); Delay(40); NoSound
end;

procedure ClearArea;
var i: Word;
begin
 for i:= 80*1 to 80*25-1 do begin mem[VRAM:2*i]:= 223;
                                  mem[VRAM:2*i+1]:= 0*16+0
                            end
end;

procedure CursorOnOff; assembler;
asm
 mov ah,3
 mov bx,0
 int $10
 xor ch,$20
 mov ah,1
 mov bx,0
 int $10
end;

procedure DrawMines;
var i: Byte;
begin
 GotoXY(63, 24);
 TextBackground(GroundCol);
 TextColor(MineCol);
 for i:=1 to MineInv do Write(#254);
 Write(' ')
end;

procedure Message(text: string);
begin
 TextColor(Black);
 TextBackground(LightGray);
 GotoXY(3, 22);
 Write(text);
 ClrEol
end;

procedure DoMove;
begin
 Message('');
 Sound(150); Delay(30); NoSound;
 BakCol:= GetPx( PlaX, PlaY );
 DrawPx( PlaX, PlaY, PlayerCol );
 Moved:= True
end;

procedure PressAnyKey;
var k: Char;
begin
 GotoXY(18, 12);
 TextColor(LightGreen);
 Write('Press any key');
 repeat
  k:= ReadKey
 until (k<>'') and (k<>#0)
end;

procedure InfoWindow;
begin
 ClearArea;
 DrawBox(15, 13, 50, 26, Red, False);
 Window(17, 8, 64, 19);
 TextBackground(Red);
 TextColor(LightGreen)
end;

procedure Info(i: Byte); {1=killed by alien, 2=killed by mine, 3=success}
begin
 InfoWindow;
 WriteLn( Spc(16, '-'),' Mission summary ', Spc(15, '-') );
 TextColor(LightGray);
 case i of
  1: WriteLn('You were captured and killed by an alien.'#10#13'You are dead.');
  2: WriteLn('You stepped on a landmine.'#10#13'You are dead.');
  3: WriteLn('You completed your mission.')
 end;
 GotoXY(1, 6);
 WriteLn('Landmines placed: ', 8-MineInv+Crate*Ord(CrateTaken) );
 WriteLn('Aliens killed: ', Kills );
 Write('Alien ship found and examined: ');
 TextColor(LightGreen);
 case i of
  1..2: begin
         WriteLn('No');
         TextColor(Black);
         GotoXY(1, 10);
         Write('Your mission was unsuccessful.')
        end;
     3: begin
         WriteLn('Yes');
         TextColor(White+Blink);
         GotoXY(17, 10);
         Write('CONGRATULATIONS')
        end
 end;
 PressAnyKey
end;

procedure MoveAlien(index: Byte);
type DirMov = (P, L, R); { primary, left, right }
var A: Alien;
    j, FinMove, max: Byte;
    dx, dy: Shortint;
    k, m: DirMov;
    Di: array[P..R] of Byte;
    Pb: array[P..R] of Word;
const DifToDir: array[-1..1,-1..1] of Byte = ( (8, 7, 6),
                                               (1, 0, 5),
                                               (2, 3, 4) );
      DirToDif: array[1..8,1..2] of Shortint = ( (0,-1), (1,-1), (1,0), (1,1), (0,1), (-1,1), (-1,0), (-1,-1) );
      DirRot: array[0..9] of Byte = (8, 1, 2, 3, 4, 5, 6, 7, 8, 1);

   function Movable(Direction: Byte): Boolean;
   var tgtX, tgtY: Byte;
   begin
    tgtX:= A.x+DirToDif[Direction,1];
    tgtY:= A.y+DirToDif[Direction,2];
    if tgtY>41 then Movable:= False
               else case GetPx( tgtX, tgtY ) of
                     PlayerCol: if (BakCol=WaterCol) and (A.Water=Avoid) then Movable:= False
                                                                         else Movable:= True;
                     GroundCol, MineCol, DeadCol: Movable:= True;
                     WaterCol: if A.Water>Avoid then Movable:= True
                                                else Movable:= False;
                     WallCol, AlienCol, ShipCol: Movable:= False
                    end
   end;

   function Sgn(x: Shortint): Shortint;
   begin
    case x of
     -128..-1: Sgn:= -1;
            0: Sgn:= 0;
       1..127: Sgn:= 1
    end
   end;

begin
 A:= Aliens[index];
 dx:= Sgn(PlaX-A.x);
 dy:= Sgn(PlaY-A.y);
 Di[P]:= DifToDir[dx,dy];
 Di[L]:= DirRot[Di[P]-1];
 Di[R]:= DirRot[Di[P]+1];
 if Odd(Pb[P]) then begin
                     Pb[P]:= 60;
                     Pb[L]:= 20;
                     Pb[R]:= 20
                    end
               else begin
                     Pb[P]:= 40;
                     Pb[L]:= 30;
                     Pb[R]:= 30
                    end;
 for k:=P to R do
   if not Movable( Di[k] ) then Pb[k]:= 0;
 j:= Pb[P]+Pb[L]+Pb[R];
 if j<100 then if j=0 then begin
                            Di[L]:= DirRot[Di[L]-1];
                            if Movable(Di[L]) then Pb[L]:= 5
                                              else Pb[L]:= 0;
                            Di[R]:= DirRot[Di[R]+1];
                            if Movable(Di[R]) then Pb[R]:= 5
                                              else Pb[R]:= 0;
                            Di[P]:= 0; Pb[P]:= 100-Pb[L]-Pb[R];
                           end
                      else begin
                            max:= 0;
                            for k:=P to R do begin
                              if Pb[k]>0 then Pb[k]:= Pb[k] * 100 div j;
                              if Pb[k]>max then begin
                                                 max:= Pb[k];
                                                 m:= k
                                                end
                                             end;
                            Inc(Pb[m], 100-Pb[P]-Pb[L]-Pb[R]);
                           end;

 j:= Succ( Random(100) );
 if j<=Pb[P] then FinMove:= Di[P];
 if (j>Pb[P]) and (j<=Pb[P]+Pb[L]) then FinMove:= Di[L];
 if j>Pb[P]+Pb[L] then FinMove:= Di[R];
 if FinMove>0 then begin
                    Sound(40); Delay(20); NoSound;
                    Delay(15);
                    dx:= DirToDif[FinMove, 1];
                    dy:= DirToDif[FinMove, 2];
                    DrawPx(A.x, A.y, A.UnderCol);
                    Inc(A.x, dx);
                    Inc(A.y, dy);
                    A.UnderCol:= GetPx(A.x, A.y);
                    if A.Water=Crawl then if A.UnderCol=WaterCol then A.Col:= WaterCol
                                                                 else A.Col:= AlienCol;
                    if (A.UnderCol=MineCol) and ( (A.x<>CrateX) or (A.y<>CrateY) or CrateTaken ) then
                      begin
                       SoundBoom;
                       A.Col:= DeadCol;
                       Message('Alien dead.');
                       Inc(Kills)
                      end;
                    DrawPx(A.x, A.y, A.Col);
                    if A.UnderCol=PlayerCol then begin
                                                  SoundSqueek;
                                                  Info(1);
                                                  LevelQuit:= True
                                                 end
                   end;
 Aliens[index]:= A
end;

procedure LevelInit;
const Doors: array[1..8,1..2] of Byte = ( (23, 11), (26, 11), (21, 9),
                                          (29, 39), (35, 38),
                                          (13, 20), (13, 24),
                                          (42, 17) );
var i, x, y: Byte;
begin
 DrawBox(1, 3, 78, 39, GroundCol, False);
 DrawBox(1, 44, 78, 5, GroundCol, False);
 TextBackground(GroundCol);
 GotoXY(3, 23);
 TextColor(PlayerCol);
 Write(#220);
 TextColor(LightGray);
 Write(' = You     ');
 TextColor(WaterCol);
 Write(#220);
 TextColor(LightGray);
 Write(' = Water   ');
 TextColor(WallCol);
 Write(#220);
 TextColor(LightGray);
 Write(' = Wall      ');
 TextColor(LightGreen);
 Write(#27#24#25#26);
 TextColor(LightGray);
 Write(' to move   ');
 TextColor(LightGreen);
 Write('Space');
 TextColor(LightGray);
 Write(' to place a Mine');
 GotoXY(3, 24);
 TextColor(AlienCol);
 Write(#220);
 TextColor(LightGray);
 Write(' = Alien   ');
 TextColor(MineCol);
 Write(#220);
 TextColor(LightGray);
 Write(' = Mine    ');
 TextColor(ShipCol);
 Write(#220);
 TextColor(LightGray);
 Write(' = Ship      ');
 TextColor(LightGreen);
 Write('W');
 TextColor(LightGray);
 Write(' to Wait      Mines:');
 for i:=0 to 7 do DrawBox(73-3*i, 3+i, 6, 8, WaterCol, False);
 for i:=0 to 5 do DrawBox(50-i, 11+3*i, 8, 5, WaterCol, False);
 for i:=0 to 13 do DrawBox(1+2*i, 38-i, 15, 4, WaterCol, False);
 DrawBox(30, 24, 19, 8, WaterCol, False);
 DrawBox(22, 7, 9, 4, GroundCol, True);
 DrawBox(30, 38, 6 ,2, GroundCol, True);
 DrawBox(36, 35, 2, 5, GroundCol, True);
 DrawBox(10, 19, 3, 9, GroundCol, True);
 DrawBox(40, 15, 2, 5, GroundCol, True);
 for i:=1 to 8 do DrawPx( Doors[i,1], Doors[i,2], GroundCol);
 DrawBox(74, 37, 3, 3, ShipCol, False);
 for i:=1 to NumAli do begin
                        repeat
                         x:= 59+Random(20);
                         y:= 22+Random(20)
                        until GetPx(x, y) = GroundCol;
                        Aliens[i].x:= x;
                        Aliens[i].y:= y;
                        Aliens[i].Col:= AlienCol;
                        DrawPx(x, y, AlienCol);
                        Aliens[i].UnderCol:= GroundCol;
                        case Succ( Random(100) ) of
                {38%}      1..38: Aliens[i].Water:= Avoid;
                {28%}     39..66: Aliens[i].Water:= Swim;
                {34%}    67..100: Aliens[i].Water:= Crawl
                        end
                       end;
 DrawPx(75, 38, GroundCol);
 PlaX:= 9+Random(9);
 PlaY:= 6+Random(9);
 BakCol:= GetPx(PlaX, PlaY);
 DrawPx(PlaX, PlaY, PlayerCol);
 repeat
  CrateX:= 9+Random(26);
  CrateY:= 29+Random(8)
 until GetPx(CrateX, CrateY) = GroundCol;
 DrawPx(CrateX, CrateY, MineCol);
 CrateTaken:= False;
 MineInv:= 8;
 DrawMines;
 Kills:= 0;
 LevelQuit:= False
end;

procedure Report;
const Texts: array[1..4,1..2] of string[134] = (
('An alien  space  vessel  crashed  on  a desolateplain near the Pecos River. A score of surviving'
+'aliens are roaming the location.',
 'The aliens  are reported to  be very strong  andextremely hostile.'),
('You  are  being   deployed  near  an   abandonedsettlement on the opposite side of the river.',
 'Your  task  is  to  inspect  the  crashsite  andexamine the wreckage of the U.F.O.'),
('The aliens will  attempt to  hunt and  kill you.You must avoid  direct engagement  and use anti-'
+'personnel landmines to eliminate them.',
 'You must be very careful, as the aliens can moveslightly faster than you.'),
('Some aliens are able to swim across the river orcrawl underwater,  temporarily unseen.  The rest'
+'will avoid contact with water.',
 'You will be equipped  with a special  float suitenabling you  to move freely  on the surface  of'
+'the river.') );
var i: Byte;
begin
 InfoWindow;
 for i:=1 to 4 do begin
                   ClrScr;
                   SoundOK;
                   WriteLn('2017-08-31   Alien incident report   Page ', i, ' of 4');
                   TextColor(LightGray);
                   WriteLn( Texts[i, 1] );
                   WriteLn;
                   Write( Texts[i, 2] );
                   PressAnyKey
                  end;
 SoundOK
end;

begin
 TextMode(CO80);
 CursorOnOff;
 TextColor(LightGreen);
 GotoXY(25, 1);
 Write('A  l  i  e  n     R  i  v  e  r');
 Delay(300);
 SoundOK;
 Randomize;
 repeat
   Window(1, 1, 80, 25);
   ClearArea;
   TextBackground(Black);
   TextColor(DarkGray);
   GotoXY(9, 2);
   Write('a little computer game by 7t7 Studios, written 14/07-04/09/2017');
   GotoXY(28, 3);
   Write('for www.high-voltage.cz');
   TextColor(LightGreen);
   GotoXY(27, 10);
   Write('Press R to read the Report', Spc(140, ' '),
         'S to Start the mission', Spc(133, ' '),
         'Ctrl+X to exit to DOS');
   for i:=2 to 6 do
     for j:=1 to i do DrawPx(33-j, 14+2*i, LightCyan);
   case ReadKey of
     's','S': begin
               InfoWindow;
               SoundOK;
               WriteLn( Spc(15, '-'), ' Mission briefing ', Spc(15, '-') );
               TextColor(LightGray);
               WriteLn('Approaching the location...');
               WriteLn('Aliens reported: ', NumAli,#10#13);
               WriteLn('Landmines in inventory: 8');
               WriteLn('A crate of another ', Crate, ' landmines will be dropped  separately.'#10#13);
               Write('Get ready!');
               PressAnyKey;
               Window(1, 1, 80, 25);
               ClearArea;
               SoundOK;
               LevelInit;
               repeat
                Action:= False;
                while KeyPressed do k:= ReadKey;
                case ReadKey of
                 #0: begin
                      Moved:=False;
                      case ReadKey of
                        #72: if GetPx(PlaX,PlaY-1)<>7 then begin
                                                            DrawPx(PlaX,PlaY,BakCol);
                                                            Dec(PlaY);
                                                            DoMove
                                                           end;
                        #75: if GetPx(PlaX-1,PlaY)<>7 then begin
                                                            DrawPx(PlaX,PlaY,BakCol);
                                                            Dec(PlaX);
                                                            DoMove
                                                           end;
                        #77: if GetPx(PlaX+1,PlaY)<>7 then begin
                                                            DrawPx(PlaX,PlaY,BakCol);
                                                            Inc(PlaX);
                                                            DoMove
                                                           end;
                        #80: if (PlaY<41) and (GetPx(PlaX,PlaY+1)<>7) then begin
                                                            DrawPx(PlaX,PlaY,BakCol);
                                                            Inc(PlaY);
                                                            DoMove
                                                           end
                      end;
                      if Moved then case BakCol of
                                     GroundCol, WaterCol, DeadCol: Action:= True;
                                     AlienCol: begin
                                                SoundSqueek;
                                                Info(1);
                                                LevelQuit:= True
                                               end;
                                     MineCol: if (PlaX=CrateX) and (PlaY=CrateY) and not CrateTaken
                                                 then begin
                                                       Inc(MineInv, Crate);
                                                       DrawMines;
                                                       CrateTaken:= True;
                                                       BakCol:= GroundCol;
                                                       SoundTwo(340, 680);
                                                       Action:= True
                                                      end
                                                 else begin
                                                       SoundBoom;
                                                       Info(2);
                                                       LevelQuit:= True
                                                      end;
                                     ShipCol: begin
                                               SoundOK;
                                               Info(3);
                                               LevelQuit:= True
                                              end
                                    end
                     end;
                 ' ': if MineInv=0 then begin
                                             SoundTwo(80, 80);
                                             Message('No more landmines.')
                                            end
                                       else case BakCol of
                                              WaterCol: begin
                                                         SoundTwo(80, 80);
                                                         Message('Can''t place mines on water.')
                                                        end;
                                              MineCol: begin
                                                        SoundTwo(80, 80);
                                                        Message('Landmine already here.')
                                                       end
                                              else begin
                                                    SoundTwo(90, 180);
                                                    BakCol:= MineCol;
                                                    Dec(MineInv);
                                                    DrawMines;
                                                    Message('Landmine placed.');
                                                    Action:= True
                                                   end
                                            end;
                 'w','W': begin
                           Message('');
                           Action:= True
                          end
                end;
                if Action then begin
                                i:= 1;
                                while (i<=NumAli) and (not LevelQuit) do
                                 begin
                                  if Aliens[i].Col<>DeadCol then MoveAlien(i);
                                  Inc(i)
                                 end
                               end
               until LevelQuit;
               SoundOK;
              end;
     'r','R': Report;
     #24: GameQuit:= True   {Ctrl+X}
   end;
 until GameQuit;
 SoundOK;
 CursorOnOff;
 TextMode(LastMode)
end.